#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define COOKIE_NAMESZ	8
#define CRYPTO_SIZE	16
#define SAFE_CACHE 	"/var/cache/mycmd"
#define FNAMESZ		127

struct cache_t {
	FILE *f;
	char *p;
	char tmp;
	char fname[FNAMESZ];
	char buf[CRYPTO_SIZE];
};

void get_cookie(const char *cookie)
{
	struct cache_t cache;

	snprintf(cache.fname, FNAMESZ, "%s/%s", SAFE_CACHE, cookie);
	cache.f = fopen(cache.fname, "r");
	if (cache.f) {
		// since we create these files ourselves, we can skip any expensive checks
		// and make our cache even faster
		cache.p = cache.buf;
		while ( (cache.tmp = fgetc(cache.f)) != '@')
			*cache.p++ = cache.tmp;
	} else {
		int i;

		memset(cache.buf, 'A', CRYPTO_SIZE); // TODO: actually compute the crypto stuff
		cache.f = fopen(cache.fname, "w");	
		for (i = 0; i < CRYPTO_SIZE; i++)
			fputc(cache.buf[i], cache.f);
		fputc('@', cache.f);
	}
	// TODO: actually use the crypto stuff
}

// no intentional errors below
void print_flag(void);
int check_cookie(const char *cookie);
int check_token(const char *token);
int main(int argc, char *argv[])
{
	const char *cookie, *token;

	if (argc != 3) {
		fprintf(stderr, "usage: mycmd <cookie> <token>\n");
		exit(EXIT_FAILURE);
	}

	cookie = argv[1];
	token  = argv[2];

	if (!check_cookie(cookie)) {
		fprintf(stderr, "Invalid cookie: only max %d alphanumeric characters allowed\n", COOKIE_NAMESZ);
		exit(EXIT_FAILURE);
	}

	get_cookie(cookie);
	if (check_token(token))
		print_flag();
	
	return 0;
}

void print_flag()
{
	char buf[1024];
	FILE *f;

	memset(buf, 0, sizeof(buf));
	if ( (f = fopen("flag.txt", "r") ) ) {
		if (fgets(buf, sizeof(buf), f))
			printf("%s", buf);
		fclose(f);
	}
	memset(buf, 0, sizeof(buf));
}

int check_cookie(const char *cookie)
{
	int n;

	for (n = 0; n < COOKIE_NAMESZ && cookie[n]; n++)
		if (!isalnum(cookie[n]))
			return 0;
	return (n < COOKIE_NAMESZ);
}

int check_token(const char *token)
{
	// TODO
	// just return false for now
	return 0;
}

